"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var discord_js_1 = require("discord.js");
var path = require("path");
var FILENAME = path.basename(__filename, path.extname(__filename));
exports.default = module.exports = (function (RED) {
    var DiscordClientNode = function (config) {
        var _this = this;
        RED.nodes.createNode(this, config);
        this.name = config.name;
        this.token = this.credentials.token;
        var client = new discord_js_1.Client({
            partials: config.partials
        });
        this.getBot = function () { return client; };
        var tryLogin = function () {
            client.login(_this.token).catch(function (error) {
                _this.emit('failed', error);
                setTimeout(tryLogin, 5000);
            });
        };
        tryLogin();
        this.on('close', function (removed, done) {
            client.destroy();
            done();
        });
    };
    RED.nodes.registerType(FILENAME, DiscordClientNode, {
        credentials: {
            token: { type: "text" }
        }
    });
});
