"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var Flatted = require("flatted");
var FILENAME = path.basename(__filename, path.extname(__filename));
exports.default = module.exports = (function (RED) {
    var DiscordGuildMemberEventNode = function (config) {
        var _this = this;
        RED.nodes.createNode(this, config);
        var clientNode = RED.nodes.getNode(config.client);
        var readyHandler = function () {
            _this.status({
                fill: 'green',
                shape: 'dot',
                text: 'ready',
            });
        };
        clientNode.getBot().on('ready', readyHandler);
        var failedHandler = function () {
            _this.status({
                fill: 'red',
                shape: 'dot',
                text: 'failed',
            });
        };
        clientNode.on('failed', failedHandler);
        var handler = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (args.leng == 0)
                args = null;
            else if (args.length == 1) {
                args = args[0];
            }
            var msg = {
                _msgid: RED.util.generateId(),
                topic: config.event,
                payload: Flatted.parse(Flatted.stringify(args)),
            };
            _this.send(msg);
        };
        clientNode.getBot().on(config.event, handler);
        this.on('close', function () {
            clientNode.getBot().off('ready', readyHandler);
            clientNode.getBot().off(config.event, handler);
            clientNode.off('failed', failedHandler);
        });
    };
    RED.nodes.registerType(FILENAME, DiscordGuildMemberEventNode);
});
