import { Node, NodeAPI, NodeContextData, NodeMessageInFlow } from "node-red";
import { Expression } from 'jsonata';
interface AsyncContext {
    get(key: string, store?: string): Promise<unknown>;
    get(key: string[], store?: string): Promise<unknown[]>;
    set(ket: string, value: unknown, store?: string): Promise<void>;
    set(ket: string[], value: unknown[], store?: string): Promise<void>;
}
export declare function asyncContext(context: NodeContextData): AsyncContext;
export declare function asyncRED(RED: NodeAPI): {
    evaluateNodePropertyAsync: <T>(node: Node, prop: string, type: string, msg: NodeMessageInFlow) => Promise<T>;
    evaluateJSONataExpressionAsync: <T_1>(node: Node, expr: Expression, msg: NodeMessageInFlow) => Promise<T_1>;
    evaluatePropertyGetter: <T_2>(node: Node, prop: string, type: string) => (msg: NodeMessageInFlow) => T_2 | Promise<T_2>;
};
export {};
